{Soutezici 13}
{Potrebne soubory:
13_hlavn.pas
soubory.pas -vkladany soubor pomoci direktivi $I
}
uses crt,graph,dos;

const vztahdite=1;
      vztahrodic=2;
      vztahmanzel=3;

      muz=false;
      zena=true;

      zije=0;

      textpohlavi:array[false..true] of string=('muz','zena');

      pid=1;
      pjmeno=2;
      pprijmeni=3;
      ppohlavi=4;
      pnarozeni=5;
      pumrti=6;

      textvztah:array[1..3] of string=('dite','rodic','partner');

type
    pvztah=^tvztah;
    posoba=^tosoba;

    tvztah=record
             typ:byte;
             skym:posoba;
             ident:string[12];
             dalsi:pvztah;
           end;
    tosoba=record
             generace:integer;
             vztahy:pvztah;
             dalsi:posoba;

             id:string[12];
             jmeno,prijmeni:string[32];
             pohlavi:boolean; {true= zena, false=muz}
             narozeni:word;
             umrti:word;
           end;

    znaky=set of char;

const normal:znaky=[' '..''];
      cisla:znaky=['0'..'9'];

var osoby:posoba;
    konec:boolean;

var maktual:posoba; {menu aktual}


{SEKCE PRO PRACI S GRAFIKOU}

procedure grafinit;
var gd,gm:integer;
begin
  gd:=detect;
  initgraph(gd,gm,'bgi');
end;

procedure grafdone;
begin
  closegraph;
end;

function getret(x,y,max:word; predtim:string; povoleno:znaky):string;
var prubezne:string;
    pozkur:byte;
    znak:char;

procedure draw;
var wx,wy:word;
begin
  setfillstyle(1,black);
  bar(x,y,x+max*textwidth('&')+1,y+textheight('W')+1);
  wx:=textwidth(prubezne+'&');
  wy:=textheight(prubezne+'W');
  setcolor(red);
  rectangle(x,y,x+wx+1,y+wy+1);
  setfillstyle(1,white);
  bar(x+1,y+1,x+wx,y+wy);
  setcolor(black);
  outtextxy(x+1,y+1,prubezne);
  line(x+textwidth(prubezne)+3,y+1,x+textwidth(prubezne)+3,y+textheight(prubezne));
end;

begin
  prubezne:=predtim;
  pozkur:=length(prubezne)+1;
  repeat
  draw;
  znak:=readkey;
  if znak=#8 then {Backspace}
  begin
    dec(pozkur);
    delete(prubezne,pozkur,1);
  end
  else
  if not(znak in[#13,#27]) then
  if znak in povoleno then
  if pozkur<max then
  begin
    inc(pozkur);
    prubezne:=prubezne+znak;
  end;
  until (znak=#13) or (znak=#27); {dokud se nestiskne enter nebo escape}
  if znak=#13 then
  getret:=prubezne
  else getret:=predtim;
end;

function getnum(x,y,max,predtim:word):longint;
var r:string;
    v:longint;
    c:integer;
begin
  str(predtim,r);
  r:=getret(x,y,max,r,cisla);
  val(r,v,c);
  getnum:=v;
end;

procedure outnum(x,y,num:longint);
var r:string;
begin
  str(num,r);
  outtextxy(x,y,r);
end;

procedure menuosob(ted:posoba);
var potom:posoba;
    i:byte;
begin
  potom:=ted;
  i:=0;
  setfillstyle(1,blue);
  bar(1,1,200,460);
  setcolor(white);
  outtextxy(10,10,'Dostupne osoby:');
  while (i<20) and (potom<>nil) do
  begin
    if i=0 then setcolor(lightred)
    else setcolor(yellow);
    outtextxy(5,i*20+30,potom^.id);
    inc(i);
    potom:=potom^.dalsi;
  end;
end;

procedure menu;
begin
  setfillstyle(1,cyan);
  bar(1,460,640,480);
  setcolor(black);
  outtextxy(1,465,'Esc-konec Ins-novy Del-smaz Sipky-pohyb Enter-editace N-nacteni U-uloz')
end;

procedure menuosoby(jake:posoba);
begin
  setfillstyle(1,darkgray);
  bar(200,1,400,460);

  setcolor(green);
  outtextxy(210,20,'ID:');
  setcolor(lightgreen);
  outnum(210,40,jake^.umrti);

  setcolor(green);
  outtextxy(210,60,'Jmeno:');
  setcolor(lightgreen);
  outtextxy(210,80,jake^.jmeno);

  setcolor(green);
  outtextxy(210,100,'Prijmeni:');
  setcolor(lightgreen);
  outtextxy(210,120,jake^.prijmeni);

  setcolor(green);
  outtextxy(210,140,'Pohlavi:');
  setcolor(lightgreen);
  outtextxy(210,160,textpohlavi[jake^.pohlavi]);

  setcolor(green);
  outtextxy(210,180,'Narozen:');
  setcolor(lightgreen);
  outnum(210,200,jake^.narozeni);

  if jake^.umrti<>0 then
  begin
    setcolor(green);
    outtextxy(210,220,'Zemrel:');
    setcolor(lightgreen);
    outnum(210,240,jake^.umrti);
  end;
end;

procedure stavosoba(p:posoba; pol:byte);
var i:byte;
    r:String;
begin
  setfillstyle(1,darkgray);
  bar(1,1,640,480);

  setcolor(green);
  outtextxy(210,20,'ID:');
  outtextxy(210,40,'Jmeno:');
  outtextxy(210,60,'Prijmeni:');
  outtextxy(210,80,'Pohlavi:');
  outtextxy(210,100,'Narozen:');
  outtextxy(210,120,'Zemrel:');
  for i:=1 to 6 do
  begin
    if i=pol then setcolor(lightred) else setcolor(lightgreen);
    case i of
    pjmeno:    r:=p^.jmeno;
    pprijmeni: r:=p^.prijmeni;
    pid:       r:=p^.id;
    ppohlavi:  r:=textpohlavi[p^.pohlavi];
    pnarozeni: str(p^.narozeni,r);
    pumrti:    str(p^.umrti,r);
    end;
    outtextxy(500,i*20,r);
  end;
  setfillstyle(1,cyan);
  bar(1,460,640,480);
  setcolor(black);
  outtextxy(5,465,'Esc-zpet Enter-editace polozky Sipky-pohyb Tab-Editace vztahu');
end;

procedure menuvztahy(jake:pvztah);
var p:pvztah;
    i:byte;
begin
  p:=jake;
  i:=0;
  setfillstyle(1,black);
  bar(1,1,640,480);
  setcolor(white);
  outtextxy(1,460,'Tab- zpet do editace osoby Sipky-pohyb Ins-pridat Del-odebrat Enter-prejit na');
  while (i<20) and (p<>nil) do
  begin
    if i=0 then setcolor(lightred) else setcolor(yellow);
    outtextxy(100,i*20+20,p^.skym^.id);
    outtextxy(500,i*20+20,textvztah[p^.typ]);
    inc(i);
    p:=p^.dalsi;
  end;
end;
{SEKCE PRO PRACI SE VZTAHY}
procedure pridejvztah(komu:posoba; typ:byte; skym:posoba);
var p:pvztah;
    typ2:byte; {urcuje vztah <skym ke komu> v zavislosti na vztahu <komu s kym>}
begin
  new(p);
  p^.typ:=typ;
  p^.skym:=skym;
  p^.ident:='';
  p^.dalsi:=komu^.vztahy;
  komu^.vztahy:=p;

  case typ of
  vztahdite:typ2:=vztahrodic;
  vztahrodic:typ2:=vztahdite;
  vztahmanzel:typ2:=vztahmanzel;
  end;

  new(p);
  p^.typ:=typ2;
  p^.skym:=komu;
  p^.dalsi:=skym^.vztahy;
  skym^.vztahy:=p;
end;

function najdipredeslyvztah(ukoho:posoba; vztah:pvztah):pvztah;
var p:pvztah;
begin
  p:=ukoho^.vztahy;
  while (p^.dalsi<>vztah) and (p<>nil) do
   p:=p^.dalsi;
  najdipredeslyvztah:=p;
end;

procedure odebervztah_def(komu:posoba; typ:byte; skym:posoba);{odebere vsechny vztahy s udanymi vlastnostmi}
var p,p2:pvztah; {p2 je predesly vztah}
begin
  p:=komu^.vztahy;
  p2:=komu^.vztahy;
  while (p<>nil) do
  begin
    if p^.typ=typ then
     if p^.skym=skym then
     begin
       if p<>komu^.vztahy then
       begin
         p2^.dalsi:=p^.dalsi;
         dispose(p);
         p:=p2^.dalsi;
       end
       else
       begin
         komu^.vztahy:=p^.dalsi;
         dispose(p);
         p:=komu^.vztahy;
       end;
     end;
    p2:=p;
    p:=p^.dalsi;
  end;
end;

procedure odebervztah(komu:posoba; vztah:pvztah); {odebere jeden vztah}
var skym:posoba;
    typ,typ2:byte; {vysvetleni typ2 viz v procedure pridejvztah}
    predesly:pvztah;
begin
  skym:=vztah^.skym;
  typ:=vztah^.typ;

  {Zrusime tentovztah}
  if komu^.vztahy<>vztah then
  begin
    predesly:=najdipredeslyvztah(komu,vztah);
    predesly^.dalsi:=vztah^.dalsi;
  end
  else
  begin
    komu^.vztahy:=vztah^.dalsi;
  end;
  dispose(vztah);

  case typ of
  vztahdite:typ2:=vztahrodic;
  vztahrodic:typ2:=vztahdite;
  vztahmanzel:typ2:=vztahmanzel;
  end;
  odebervztah_def(skym,typ2,komu);
end;

procedure zrusvztahy(komu:posoba);
begin
  while komu^.vztahy<>nil do
  odebervztah(komu,komu^.vztahy);
end;

{SEKCE PRO PRACI S OSOBAMI}
procedure novaosoba;
var p:posoba;
begin
  new(p);
  p^.generace:=-1;
  p^.vztahy:=nil;
  p^.dalsi:=osoby;

  p^.id:='...';
  p^.jmeno:='..'; p^.prijmeni:='..';
  p^.pohlavi:=muz;
  p^.narozeni:=1900; p^.umrti:=zije;
  osoby:=p;
end;

function predeslaosoba(koho:posoba):posoba;
var p:posoba;
begin
  p:=osoby;
  while (p^.dalsi<>koho) and (p<>nil) do
  begin
    p:=p^.dalsi;
  end;
  predeslaosoba:=p;
end;

procedure zrusosobu(jakou:posoba);
var predemnou:posoba;
begin
  zrusvztahy(jakou);
  if jakou<>osoby then
  begin
    predemnou:=predeslaosoba(jakou);
    predemnou^.dalsi:=jakou^.dalsi;
  end
  else
  begin
    osoby:=jakou^.dalsi;
  end;
  dispose(jakou);
end;

procedure zrusosoby;
begin
  while osoby<>nil do
  zrusosobu(osoby);
end;

function neurcenygenerace:boolean;
var p:posoba;
    jo:boolean;
begin
  p:=osoby;
  jo:=false;
  while (not jo) and (p<>nil) do
  begin
    if p^.generace=-1 then jo:=true;
    p:=p^.dalsi;
  end;
  neurcenygenerace:=jo;
end;

{procedure definujgenerace;
var p:posoba;
    v:pvztah;
begin
  while neurcenygenerace do
  begin
    p:=osoby;
    while (p<>nil) and (p^.generace<>-1) do
    begin
      p:=p^.dalsi;
    end;
    v:=p^.vztahy;
    while v<>nil do
    begin
      if p^.vztahy=vztahrodic then begin end;

    end;
  end;
end;}

{TELO PROGRAMU}
{$I soubory.pas}


procedure novyvztah(ci:posoba);
var typ:byte;
    aktual:posoba;
    z:char;
procedure nahoru;
var p:posoba;
begin
  p:=osoby;
  if aktual<>osoby then
  p:=predeslaosoba(aktual);
  aktual:=p;
end;

procedure dolu;
begin
  if aktual<>nil then
  if aktual^.dalsi<>nil then
  aktual:=aktual^.dalsi;
end;

begin
  cleardevice;
  outtextxy(100,20,'[1] .. nove dite');
  outtextxy(100,50,'[2] .. novy rodic');
  typ:=200;
  case readkey of
  '1':typ:=vztahdite;
  '2':typ:=vztahrodic;
  end;
  cleardevice;
  if typ=200 then exit;

  aktual:=osoby;
  setcolor(white);
  outtextxy(1,465,'Enter-vyber osoby, ke ktere bude vztah Sipky-pohyb');
  repeat
  menuosob(aktual);
  if aktual<>nil then
  menuosoby(aktual);
  z:=readkey;
  case z of
  #72:nahoru;
  #80:dolu;
  end;
  until z=#13;
  pridejvztah(ci,typ,aktual);
end;

function editujvztahy(ci:posoba):byte;
var aktual:pvztah;
    z:char;
begin
  aktual:=ci^.vztahy;
  editujvztahy:=0;
  repeat
  menuvztahy(aktual);
  z:=readkey;
  case z of
  #72:begin{nahoru}
        if aktual<>ci^.vztahy then
        begin
          aktual:=najdipredeslyvztah(ci,aktual);
        end;
      end;
  #80:begin{dolu}
        if aktual<>nil then
        if aktual^.dalsi<>nil then
        aktual:=aktual^.dalsi;
      end;
  #82:begin{insert}
        novyvztah(ci);
        aktual:=ci^.vztahy;
      end;
  #13:if aktual<>nil then
      if aktual^.skym<>nil then
       begin
        maktual:=aktual^.skym;
        z:=#9;
        editujvztahy:=1;
      end;
  end;
  until z=#9;
end;

procedure edituj(p:posoba);
const max=6;
var polozka:byte;
    z:char;
begin
  polozka:=1;
  repeat
  stavosoba(p,polozka);
  z:=readkey;
  case z of
  #72:dec(polozka);
  #80:inc(polozka);
  #13:
      case polozka of
      pid:p^.id:=getret(200,400,32,p^.id,normal);
      pjmeno:p^.jmeno:=getret(200,400,32,p^.jmeno,normal);
      pprijmeni:p^.prijmeni:=getret(200,400,32,p^.prijmeni,normal);
      ppohlavi:p^.pohlavi:=not p^.pohlavi;
      pnarozeni:p^.narozeni:=getnum(200,400,5,p^.narozeni);
      pumrti:p^.umrti:=getnum(200,400,5,p^.umrti);
      end;
  #9:if editujvztahy(p)=1 then z:=#27;
  end;
  if polozka<1 then polozka:=max;
  if polozka>max then polozka:=1;
  until z=#27;
end;

procedure nactisoubor;
var sr:searchrec;
    x,y:byte;
    r:string;
begin
  cleardevice;
  findfirst('*.xml',archive,sr);
  x:=1;
  y:=0;
  while doserror=0 do
  begin
    inc(y);
    if y=20 then begin y:=1; inc(x); end;
    outtextxy(x*100,y*20,sr.name);
    findnext(sr);
  end;
  r:=getret(2,440,150,'',normal);
  if pos('.xml',r)=0 then r:=r+'.xml';
  findfirst(r,archive,sr);
  if doserror=0 then nahrajsoubor(r);
end;

procedure uloz;
var r:string;
begin
  cleardevice;
  r:=getret(200,100,150,'',normal);
  if r='' then exit;
  if pos('.xml',r)=0 then r:=r+'.xml';
  safe(r);
end;


procedure prubeh;
var aktual:posoba;

procedure nahoru;
var p:posoba;
begin
  p:=osoby;
  if maktual<>osoby then
  p:=predeslaosoba(maktual);
  maktual:=p;
end;

procedure dolu;
begin
  if maktual<>nil then
  if maktual^.dalsi<>nil then
  maktual:=maktual^.dalsi;
end;

begin
  maktual:=osoby;
  menu;
  repeat
  menuosob(maktual);
  if maktual<>nil then
  menuosoby(maktual);
  case upcase(readkey) of
  #27:konec:=true; {konec Escapem}
  #82:begin novaosoba; maktual:=osoby; end; {insert}
  #83:begin zrusosobu(maktual); maktual:=osoby; end; {delete}
  #72:nahoru;
  #80:dolu;
  #13:if maktual<>nil then begin edituj(maktual); cleardevice; menu; end;
  'N':begin nactisoubor; maktual:=osoby; menu; end;
  'U':begin uloz; menu; end;
  end;
  until konec;
end;


begin
  osoby:=nil;
  grafinit;
  prubeh;
  zrusosoby;
  grafdone;
end.